Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 2823)
@@ -6,4 +6,5 @@
    !! History :   1.0  !  2004     (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-04  (O. Aumont, C. Ethe) Limitation for iron modelled in quota 
    !!----------------------------------------------------------------------
 #if defined key_pisces
@@ -14,8 +15,8 @@
    !!   p4z_lim_init   :   Read the namelist 
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
+   USE oce_trc         ! Shared ocean-passive tracers variables
+   USE trc             ! Tracers defined
+   USE sms_pisces      ! PISCES variables
+   USE p4zopt          ! Optical
 
    IMPLICIT NONE
@@ -26,19 +27,27 @@
 
    !! * Shared module variables
-   REAL(wp), PUBLIC ::   &
-     conc0     = 2.e-6_wp      ,  &  !:
-     conc1     = 10.e-6_wp     ,  &  !:
-     conc2     = 2.e-11_wp     ,  &  !:
-     conc2m    = 8.E-11_wp     ,  &  !:
-     conc3     = 1.e-10_wp     ,  &  !:
-     conc3m    = 4.e-10_wp     ,  &  !:
-     concnnh4  = 1.e-7_wp      ,  &  !:
-     concdnh4  = 5.e-7_wp      ,  &  !:
-     xksi1     = 2.E-6_wp      ,  &  !:
-     xksi2     = 3.33E-6_wp    ,  &  !:
-     xkdoc     = 417.E-6_wp    ,  &  !:
-     caco3r    = 0.3_wp              !:
-
-
+   REAL(wp), PUBLIC ::  conc0     = 2.e-6_wp      !:  NO3, PO4 half saturation   
+   REAL(wp), PUBLIC ::  conc1     = 8.e-6_wp      !:  Phosphate half saturation for diatoms  
+   REAL(wp), PUBLIC ::  conc2     = 1.e-9_wp      !:  Iron half saturation for nanophyto 
+   REAL(wp), PUBLIC ::  conc2m    = 3.e-9_wp      !:  Max iron half saturation for nanophyto 
+   REAL(wp), PUBLIC ::  conc3     = 2.e-9_wp      !:  Iron half saturation for diatoms  
+   REAL(wp), PUBLIC ::  conc3m    = 8.e-9_wp      !:  Max iron half saturation for diatoms 
+   REAL(wp), PUBLIC ::  concnnh4  = 1.e-7_wp      !:  NH4 half saturation for phyto  
+   REAL(wp), PUBLIC ::  concdnh4  = 4.e-7_wp      !:  NH4 half saturation for diatoms
+   REAL(wp), PUBLIC ::  xksi1     = 2.E-6_wp      !:  half saturation constant for Si uptake 
+   REAL(wp), PUBLIC ::  xksi2     = 3.33e-6_wp    !:  half saturation constant for Si/C 
+   REAL(wp), PUBLIC ::  xkdoc     = 417.e-6_wp    !:  2nd half-sat. of DOC remineralization  
+   REAL(wp), PUBLIC ::  concfebac = 1.E-11_wp     !:  Fe half saturation for bacteria 
+   REAL(wp), PUBLIC ::  qnfelim   = 7.E-6_wp      !:  optimal Fe quota for nanophyto
+   REAL(wp), PUBLIC ::  qdfelim   = 7.E-6_wp      !:  optimal Fe quota for diatoms
+   REAL(wp), PUBLIC ::  caco3r    = 0.16_wp       !:  mean rainratio 
+
+   ! Coefficient for iron limitation
+!   REAL(wp) ::  xcoef1   = 0.0016 
+!   REAL(wp) ::  xcoef2   = 1.21E-5 * 1.5 
+!   REAL(wp) ::  xcoef3   = 1.15E-4 / 7.625 /  55.85
+   REAL(wp) ::  xcoef1   = 0.0016  / 55.85  
+   REAL(wp) ::  xcoef2   = 1.21E-5 * 14. / 55.85 / 7.625 * 0.5 * 1.5
+   REAL(wp) ::  xcoef3   = 1.15E-4 * 14. / 55.85 / 7.625 * 0.5 
    !!* Substitution
 #  include "top_substitute.h90"
@@ -60,105 +69,104 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      !
       INTEGER, INTENT(in)  :: kt
+      !
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zlim1, zlim2, zlim3, zlim4, zno3, zferlim
-      REAL(wp) ::   zconctemp, zconctemp2, zconctempn, zconctempn2
-      REAL(wp) ::   ztemp, zdenom
+      REAL(wp) ::   zconcd, zconcd2, zconcn, zconcn2
+      REAL(wp) ::   z1_trndia, z1_trnphy, ztem1, ztem2, zetot1, zetot2
+      REAL(wp) ::   zdenom, zratio, zironmin
+      REAL(wp) ::   zconc1d, zconc1dnh4, zconc0n, zconc0nnh4   
       !!---------------------------------------------------------------------
-
-
-      !  Tuning of the iron concentration to a minimum
-      !  level that is set to the detection limit
-      !  -------------------------------------
 
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zno3=trn(ji,jj,jk,jpno3)
-               zferlim = MAX( 1.5e-11*(zno3/40E-6)**2, 3e-12 )
-               zferlim = MIN( zferlim, 1.5e-11 )
+               
+               ! Tuning of the iron concentration to a minimum level that is set to the detection limit
+               !-------------------------------------
+               zno3    = trn(ji,jj,jk,jpno3) / 40.e-6
+               zferlim = MAX( 2e-11 * zno3 * zno3, 5e-12 )
+               zferlim = MIN( zferlim, 3e-11 )
                trn(ji,jj,jk,jpfer) = MAX( trn(ji,jj,jk,jpfer), zferlim )
-            END DO
+
+               ! Computation of a variable Ks for iron on diatoms taking into account
+               ! that increasing biomass is made of generally bigger cells
+               !------------------------------------------------
+               zconcd   = MAX( 0.e0 , trn(ji,jj,jk,jpdia) - 5.e-7 )
+               zconcd2  = trn(ji,jj,jk,jpdia) - zconcd
+               zconcn   = MAX( 0.e0 , trn(ji,jj,jk,jpphy) - 1.e-6 )
+               zconcn2  = trn(ji,jj,jk,jpphy) - zconcn
+               z1_trnphy   = 1. / ( trn(ji,jj,jk,jpphy) + rtrn )
+               z1_trndia   = 1. / ( trn(ji,jj,jk,jpdia) + rtrn )
+
+               concdfe(ji,jj,jk) = MAX( conc3       , ( zconcd2 *      conc3    + conc3m        * zconcd ) * z1_trndia )
+               zconc1d           = MAX( 2.* conc0   , ( zconcd2 * 2. * conc0    + conc1         * zconcd ) * z1_trndia )
+               zconc1dnh4        = MAX( 2.* concnnh4, ( zconcd2 * 2. * concnnh4 + concdnh4      * zconcd ) * z1_trndia )
+
+               concnfe(ji,jj,jk) = MAX( conc2       , ( zconcn2 * conc2         + conc2m        * zconcn ) * z1_trnphy )
+               zconc0n           = MAX( conc0       , ( zconcn2 * conc0         + 2. * conc0    * zconcn ) * z1_trnphy )
+               zconc0nnh4        = MAX( concnnh4    , ( zconcn2 * concnnh4      + 2. * concnnh4 * zconcn ) * z1_trnphy )
+
+               ! Michaelis-Menten Limitation term for nutrients Small flagellates
+               ! -----------------------------------------------
+               zdenom = 1. /  ( zconc0n * zconc0nnh4 + zconc0nnh4 * trn(ji,jj,jk,jpno3) + zconc0n * trn(ji,jj,jk,jpnh4) )
+               xnanono3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * zconc0nnh4 * zdenom
+               xnanonh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * zconc0n    * zdenom
+               !
+               zlim1    = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
+               zlim2    = trn(ji,jj,jk,jppo4) / ( trn(ji,jj,jk,jppo4) + zconc0nnh4 )
+               zratio   = trn(ji,jj,jk,jpnfe) * z1_trnphy 
+               zironmin = xcoef1 * trn(ji,jj,jk,jpnch) * z1_trnphy + xcoef2 * zlim1 + xcoef3 * xnanono3(ji,jj,jk)
+               zlim3    = MAX( 0.,( zratio - zironmin ) / qnfelim )
+               xlimnfe(ji,jj,jk) = MIN( 1., zlim3 )
+               xlimphy(ji,jj,jk) = MIN( zlim1, zlim2, zlim3 )
+               !
+               zlim1    = trn(ji,jj,jk,jpnh4) / ( concnnh4 + trn(ji,jj,jk,jpnh4) )
+               zlim3    = trn(ji,jj,jk,jpfer) / ( concfebac+ trn(ji,jj,jk,jpfer) )
+               zlim4    = trn(ji,jj,jk,jpdoc) / ( xkdoc   + trn(ji,jj,jk,jpdoc) )
+               xlimbac(ji,jj,jk) = MIN( zlim1, zlim2, zlim3 ) * zlim4
+
+               !   Michaelis-Menten Limitation term for nutrients Diatoms
+               !   ----------------------------------------------
+               zdenom   = 1. / ( zconc1d * zconc1dnh4 + zconc1dnh4 * trn(ji,jj,jk,jpno3) + zconc1d * trn(ji,jj,jk,jpnh4) )
+               xdiatno3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * zconc1dnh4 * zdenom
+               xdiatnh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * zconc1d    * zdenom
+               !
+               zlim1    = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
+               zlim2    = trn(ji,jj,jk,jppo4) / ( trn(ji,jj,jk,jppo4) + zconc1dnh4  )
+               zlim3    = trn(ji,jj,jk,jpsil) / ( trn(ji,jj,jk,jpsil) + xksi(ji,jj) )
+               zratio   = trn(ji,jj,jk,jpdfe)/(trn(ji,jj,jk,jpdia)+rtrn)
+               zironmin = xcoef1 * trn(ji,jj,jk,jpdch) * z1_trndia + xcoef2 * zlim1 + xcoef3 * xdiatno3(ji,jj,jk)
+               zlim4    = MAX( 0., ( zratio - zironmin ) / qdfelim )
+               xlimdfe(ji,jj,jk) = MIN( 1., zlim4 )
+               xlimdia(ji,jj,jk) = MIN( zlim1, zlim2, zlim3, zlim4 )
+               xlimsi(ji,jj,jk)  = MIN( zlim1, zlim2, zlim4 )
+           END DO
          END DO
       END DO
 
-      !  Computation of a variable Ks for iron on diatoms taking into account
-      !  that increasing biomass is made of generally bigger cells
-      !  ------------------------------------------------
-
+      ! Compute the fraction of nanophytoplankton that is made of calcifiers
+      ! --------------------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zconctemp   = MAX( 0.e0 , trn(ji,jj,jk,jpdia)-5e-7 )
-               zconctemp2  = trn(ji,jj,jk,jpdia) - zconctemp
-               zconctempn  = MAX( 0.e0 , trn(ji,jj,jk,jpphy)-1e-6 )
-               zconctempn2 = trn(ji,jj,jk,jpphy) - zconctempn
-               concdfe(ji,jj,jk) = ( zconctemp2 * conc3 + conc3m * zconctemp)   &
-                  &              / ( trn(ji,jj,jk,jpdia) + rtrn )
-               concdfe(ji,jj,jk) = MAX( conc3, concdfe(ji,jj,jk) )
-               concnfe(ji,jj,jk) = ( zconctempn2 * conc2 + conc2m * zconctempn)   &
-                  &              / ( trn(ji,jj,jk,jpphy) + rtrn )
-               concnfe(ji,jj,jk) = MAX( conc2, concnfe(ji,jj,jk) )
-            END DO
-         END DO
-      END DO
-
-     !  Michaelis-Menten Limitation term for nutrients Small flagellates
-     !      -----------------------------------------------
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-              zdenom = 1. / &
-                  & ( conc0 * concnnh4 + concnnh4 * trn(ji,jj,jk,jpno3) + conc0 * trn(ji,jj,jk,jpnh4) )
-               xnanono3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * concnnh4 * zdenom
-               xnanonh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * conc0    * zdenom
-
-               zlim1 = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
-               zlim2 = trn(ji,jj,jk,jppo4) / ( trn(ji,jj,jk,jppo4) + concnnh4          ) 
-               zlim3 = trn(ji,jj,jk,jpfer) / ( trn(ji,jj,jk,jpfer) + concnfe(ji,jj,jk) )
-               xlimphy(ji,jj,jk) = MIN( zlim1, zlim2, zlim3 )
-               zlim1 = trn(ji,jj,jk,jpnh4) / ( concnnh4 + trn(ji,jj,jk,jpnh4) )
-               zlim3 = trn(ji,jj,jk,jpfer) / ( conc2    + trn(ji,jj,jk,jpfer) )
-               zlim4 = trn(ji,jj,jk,jpdoc) / ( xkdoc   + trn(ji,jj,jk,jpdoc) )
-               xlimbac(ji,jj,jk) = MIN( zlim1, zlim2, zlim3 ) * zlim4
-
-            END DO
-         END DO
-      END DO
-
-      !   Michaelis-Menten Limitation term for nutrients Diatoms
-      !   ----------------------------------------------
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-              zdenom = 1. / &
-                  & ( conc1 * concdnh4 + concdnh4 * trn(ji,jj,jk,jpno3) + conc1 * trn(ji,jj,jk,jpnh4) )
-
-               xdiatno3(ji,jj,jk) = trn(ji,jj,jk,jpno3) * concdnh4 * zdenom
-               xdiatnh4(ji,jj,jk) = trn(ji,jj,jk,jpnh4) * conc1    * zdenom 
-
-               zlim1 = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
-               zlim2 = trn(ji,jj,jk,jppo4) / ( trn(ji,jj,jk,jppo4) + concdnh4          )
-               zlim3 = trn(ji,jj,jk,jpsil) / ( trn(ji,jj,jk,jpsil) + xksi   (ji,jj)    )
-               zlim4 = trn(ji,jj,jk,jpfer) / ( trn(ji,jj,jk,jpfer) + concdfe(ji,jj,jk) )
-               xlimdia(ji,jj,jk) = MIN( zlim1, zlim2, zlim3, zlim4 )
-
-            END DO
-         END DO
-      END DO
-
-
-      ! Compute the fraction of nanophytoplankton that is made of calcifiers
-      ! --------------------------------------------------------------------
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ztemp = MAX( 0., tsn(ji,jj,jk,jp_tem) )
-               xfracal(ji,jj,jk) = caco3r * xlimphy(ji,jj,jk)   &
-                  &                       * MAX( 0.0001, ztemp / ( 2.+ ztemp ) )   &
-                  &                       * MAX( 1., trn(ji,jj,jk,jpphy) * 1.e6 / 2. )
+               zlim1 =  ( trn(ji,jj,jk,jpno3) * concnnh4 + trn(ji,jj,jk,jpnh4) * conc0 )    &
+                  &   / ( conc0 * concnnh4 + concnnh4 * trn(ji,jj,jk,jpno3)  + conc0 * trn(ji,jj,jk,jpnh4) ) 
+               zlim2  = trn(ji,jj,jk,jppo4) / ( trn(ji,jj,jk,jppo4) + concnnh4 )
+               zlim3  = trn(ji,jj,jk,jpfer) / ( trn(ji,jj,jk,jpfer) + concfebac )
+               ztem1  = MAX( 0., tsn(ji,jj,jk,jp_tem) )
+               ztem2  = tsn(ji,jj,jk,jp_tem) - 10.
+               zetot1 = MAX( 0., etot(ji,jj,jk) - 1.) / ( 4. + etot(ji,jj,jk) ) 
+               zetot2 = 1. / ( 30. + etot(ji,jj,jk) ) 
+
+               xfracal(ji,jj,jk) = caco3r * MIN( zlim1, zlim2, zlim3 )                  &
+                  &                       * ztem1 / ( 0.1 + ztem1 )                     &
+                  &                       * MAX( 1., trn(ji,jj,jk,jpphy) * 1.e6 / 2. )  &
+                  &                       * 2.325 * zetot1 * 30. * zetot2               &
+                  &                       * ( 1. + EXP(-ztem2 * ztem2 / 25. ) )         &
+                  &                       * MIN( 1., 50. / ( hmld(ji,jj) + rtrn ) )
                xfracal(ji,jj,jk) = MIN( 0.8 , xfracal(ji,jj,jk) )
-               xfracal(ji,jj,jk) = MAX( 0.01, xfracal(ji,jj,jk) )
+               xfracal(ji,jj,jk) = MAX( 0.02, xfracal(ji,jj,jk) )
             END DO
          END DO
@@ -182,8 +190,9 @@
 
       NAMELIST/nampislim/ conc0, conc1, conc2, conc2m, conc3, conc3m,   &
-         &             concnnh4, concdnh4, xksi1, xksi2, xkdoc, caco3r
-
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampislim )
+         &                concnnh4, concdnh4, xksi1, xksi2, xkdoc,      &
+         &                concfebac, qnfelim, qdfelim, caco3r
+
+      REWIND( numnatp )                     ! read numnat
+      READ  ( numnatp, nampislim )
 
       IF(lwp) THEN                         ! control print
@@ -192,8 +201,8 @@
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
          WRITE(numout,*) '    mean rainratio                            caco3r    =', caco3r
-         WRITE(numout,*) '    NO3, PO4 half saturation                  conc0      =', conc0
+         WRITE(numout,*) '    NO3, PO4 half saturation                  conc0     =', conc0
          WRITE(numout,*) '    half saturation constant for Si uptake    xksi1     =', xksi1
          WRITE(numout,*) '    half saturation constant for Si/C         xksi2     =', xksi2
-         WRITE(numout,*) '    2nd half-sat. of DOC remineralization     xkdoc    =', xkdoc
+         WRITE(numout,*) '    2nd half-sat. of DOC remineralization     xkdoc     =', xkdoc
          WRITE(numout,*) '    Phosphate half saturation for diatoms     conc1     =', conc1
          WRITE(numout,*) '    Iron half saturation for phyto            conc2     =', conc2
@@ -203,4 +212,7 @@
          WRITE(numout,*) '    NH4 half saturation for phyto             concnnh4  =', concnnh4
          WRITE(numout,*) '    NH4 half saturation for diatoms           concdnh4  =', concdnh4
+         WRITE(numout,*) '    Fe half saturation for bacteria           concfebac =', concfebac
+         WRITE(numout,*) '    optimal Fe quota for nano.                qnfelim   =', qnfelim
+         WRITE(numout,*) '    Optimal Fe quota for diatoms              qdfelim   =', qdfelim
       ENDIF
 
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2823)
@@ -9,4 +9,6 @@
    !!             1.0  !  2004     (O. Aumont) modifications
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!                  !  2011-02  (J. Simeon, J. Orr)  Calcon salinity dependence
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Improvment of calcite dissolution
    !!----------------------------------------------------------------------
 #if defined key_pisces
@@ -17,10 +19,9 @@
    !!   p4z_lys_init   :   Read the namelist parameters
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc
-   USE sms_pisces
-   USE prtctl_trc
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -62,10 +63,8 @@
       INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  ::   ji, jj, jk, jn
-      REAL(wp) ::   zbot, zalk, zdic, zph, zremco3, zah2
-      REAL(wp) ::   zdispot, zfact, zalka
+      REAL(wp) ::   zalk, zdic, zph, zremco3, zah2
+      REAL(wp) ::   zdispot, zfact, zcalcon, zalka, zaldi
       REAL(wp) ::   zomegaca, zexcess, zexcess0
-#if defined key_diatrc && defined key_iomput
       REAL(wp) ::   zrfact2
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -91,33 +90,19 @@
 !CDIR NOVERRCHK
                DO ji = 1, jpi
-
-                  ! SET DUMMY VARIABLE FOR TOTAL BORATE
-                  zbot  = borat(ji,jj,jk)
-
-                  ! SET DUMMY VARIABLE FOR TOTAL BORATE
-                  zbot  = borat(ji,jj,jk)
-                  zfact = rhop (ji,jj,jk) / 1000. + rtrn
-
-                  ! SET DUMMY VARIABLE FOR [H+]
-                  zph   = hi(ji,jj,jk) * tmask(ji,jj,jk) / zfact + ( 1.-tmask(ji,jj,jk) ) * 1.e-9
-
-                  ! SET DUMMY VARIABLE FOR [SUM(CO2)]GIVEN 
+                  zfact = rhop(ji,jj,jk) / 1000. + rtrn
+                  zph  = hi(ji,jj,jk) * tmask(ji,jj,jk) / zfact + ( 1.-tmask(ji,jj,jk) ) * 1.e-9 ! [H+]
                   zdic  = trn(ji,jj,jk,jpdic) / zfact
                   zalka = trn(ji,jj,jk,jptal) / zfact
 
                   ! CALCULATE [ALK]([CO3--], [HCO3-])
-                  zalk  = zalka - (  akw3(ji,jj,jk) / zph - zph   &
-                     &             + zbot / (1.+ zph / akb3(ji,jj,jk) )  )
+                  zalk  = zalka - ( akw3(ji,jj,jk) / zph - zph + borat(ji,jj,jk) / ( 1. + zph / akb3(ji,jj,jk) ) )
 
                   ! CALCULATE [H+] and [CO3--]
-                  zah2 = SQRT( (zdic-zalk)*(zdic-zalk)+   &
-                     &     4.*(zalk*ak23(ji,jj,jk)/ak13(ji,jj,jk))   &
-                     &     *(2*zdic-zalk))
-
-                  zah2=0.5*ak13(ji,jj,jk)/zalk*((zdic-zalk)+zah2)
-                  zco3(ji,jj,jk) = zalk/(2.+zah2/ak23(ji,jj,jk))*zfact
-
-                  hi(ji,jj,jk)  = zah2*zfact
-
+                  zaldi = zdic - zalk
+                  zah2  = SQRT( zaldi * zaldi + 4.* ( zalk * ak23(ji,jj,jk) / ak13(ji,jj,jk) ) * ( zdic + zaldi ) )
+                  zah2  = 0.5 * ak13(ji,jj,jk) / zalk * ( zaldi + zah2 )
+                  !
+                  zco3(ji,jj,jk) = zalk / ( 2. + zah2 / ak23(ji,jj,jk) ) * zfact
+                  hi(ji,jj,jk)   = zah2 * zfact
                END DO
             END DO
@@ -137,8 +122,12 @@
 
                ! DEVIATION OF [CO3--] FROM SATURATION VALUE
-               zomegaca = ( calcon * zco3(ji,jj,jk) ) / aksp(ji,jj,jk)
+               ! Salinity dependance in zomegaca and divide by rhop/1000 to have good units
+               zcalcon  = calcon * ( tsn(ji,jj,jk,jp_sal) / 35._wp )
+               zfact    = rhop(ji,jj,jk) / 1000._wp
+               zomegaca = ( zcalcon * zco3(ji,jj,jk) * zfact ) / aksp(ji,jj,jk) 
 
                ! SET DEGREE OF UNDER-/SUPERSATURATION
-               zexcess0 = MAX( 0., ( 1.- zomegaca ) )
+               excess(ji,jj,jk) = 1._wp - zomegaca
+               zexcess0 = MAX( 0., excess(ji,jj,jk) )
                zexcess  = zexcess0**nca
 
@@ -166,18 +155,18 @@
          END DO
       END DO
-
+      !
 # if defined key_diatrc
-#  if ! defined key_iomput
-      trc3d(:,:,:,jp_pcs0_3d    ) = hi  (:,:,:)          * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 1) = zco3(:,:,:)          * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 2) = aksp(:,:,:) / calcon * tmask(:,:,:)
-#  else
-      zrfact2 = 1.e3 * rfact2r
-      CALL iom_put( "PH"    , hi      (:,:,:)           * tmask(:,:,:) )
-      CALL iom_put( "CO3"   , zco3    (:,:,:)           * tmask(:,:,:) )
-      CALL iom_put( "CO3sat", aksp    (:,:,:) / calcon  * tmask(:,:,:) )
-      CALL iom_put( "DCAL"  , zcaldiss(:,:,:) * zrfact2 * tmask(:,:,:) )
-#  endif
-# endif
+#  if defined key_iomput
+       zrfact2 = 1.e3 * rfact2r
+       CALL iom_put( "PH"    , hi      (:,:,:)           * tmask(:,:,:) )
+       CALL iom_put( "CO3"   , zco3    (:,:,:)           * tmask(:,:,:) )
+       CALL iom_put( "CO3sat", aksp    (:,:,:) / calcon  * tmask(:,:,:) )
+       CALL iom_put( "DCAL"  , zcaldiss(:,:,:) * zrfact2 * tmask(:,:,:) )
+#else
+       trc3d(:,:,:,jp_pcs0_3d    ) = hi  (:,:,:)          * tmask(:,:,:)
+       trc3d(:,:,:,jp_pcs0_3d + 1) = zco3(:,:,:)          * tmask(:,:,:)
+       trc3d(:,:,:,jp_pcs0_3d + 2) = aksp(:,:,:) / calcon * tmask(:,:,:)
+#endif
+#endif
       !
        IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -207,6 +196,6 @@
       NAMELIST/nampiscal/ kdca, nca
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampiscal )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampiscal )
 
       IF(lwp) THEN                         ! control print
